/* tslint:disable max-line-length */
import { ComponentFixture, TestBed, inject, fakeAsync, tick } from '@angular/core/testing';
import { NgbActiveModal } from '@ng-bootstrap/ng-bootstrap';
import { Observable, of } from 'rxjs';
import { JhiEventManager } from 'ng-jhipster';

import { FaeBooTestModule } from '../../../test.module';
import { ProfileDeleteDialogComponent } from 'app/entities/profile/profile-delete-dialog.component';
import { ProfileService } from 'app/entities/profile/profile.service';

describe('Component Tests', () => {
    describe('Profile Management Delete Component', () => {
        let comp: ProfileDeleteDialogComponent;
        let fixture: ComponentFixture<ProfileDeleteDialogComponent>;
        let service: ProfileService;
        let mockEventManager: any;
        let mockActiveModal: any;

        beforeEach(() => {
            TestBed.configureTestingModule({
                imports: [FaeBooTestModule],
                declarations: [ProfileDeleteDialogComponent]
            })
                .overrideTemplate(ProfileDeleteDialogComponent, '')
                .compileComponents();
            fixture = TestBed.createComponent(ProfileDeleteDialogComponent);
            comp = fixture.componentInstance;
            service = fixture.debugElement.injector.get(ProfileService);
            mockEventManager = fixture.debugElement.injector.get(JhiEventManager);
            mockActiveModal = fixture.debugElement.injector.get(NgbActiveModal);
        });

        describe('confirmDelete', () => {
            it('Should call delete service on confirmDelete', inject(
                [],
                fakeAsync(() => {
                    // GIVEN
                    spyOn(service, 'delete').and.returnValue(of({}));

                    // WHEN
                    comp.confirmDelete(123);
                    tick();

                    // THEN
                    expect(service.delete).toHaveBeenCalledWith(123);
                    expect(mockActiveModal.dismissSpy).toHaveBeenCalled();
                    expect(mockEventManager.broadcastSpy).toHaveBeenCalled();
                })
            ));
        });
    });
});
